# pyright: reportUnusedImport=false
import struct
from typing import Optional, Self, Sequence
from .. import abcs
from ..core import Request, serialize_bytes_to
_bytes = bytes | bytearray | memoryview
def get_config() -> Request[abcs.Config]:
    _buffer = bytearray(b'k\x18\xf9\xc4')
    return Request(b'' + _buffer)
def get_nearest_dc() -> Request[abcs.NearestDc]:
    _buffer = bytearray(b'&0\xb3\x1f')
    return Request(b'' + _buffer)
def get_app_update(*, source: str) -> Request[abcs.help.AppUpdate]:
    _buffer = bytearray(b'}Z-R')
    serialize_bytes_to(_buffer, source.encode('utf-8'))
    return Request(b'' + _buffer)
def get_invite_text() -> Request[abcs.help.InviteText]:
    _buffer = bytearray(b'C#9M')
    return Request(b'' + _buffer)
def get_support() -> Request[abcs.help.Support]:
    _buffer = bytearray(b'\xcd\x08\xdf\x9c')
    return Request(b'' + _buffer)
def get_app_changelog(*, prev_app_version: str) -> Request[abcs.Updates]:
    _buffer = bytearray(b'o\xef\x10\x90')
    serialize_bytes_to(_buffer, prev_app_version.encode('utf-8'))
    return Request(b'' + _buffer)
def set_bot_updates_status(*, pending_updates_count: int, message: str) -> Request[bool]:
    _buffer = bytearray(b'\xcd\xcf"\xec')
    _buffer += struct.pack('<i', pending_updates_count)
    serialize_bytes_to(_buffer, message.encode('utf-8'))
    return Request(b'' + _buffer)
def get_cdn_config() -> Request[abcs.CdnConfig]:
    _buffer = bytearray(b'B\x93\x02R')
    return Request(b'' + _buffer)
def get_recent_me_urls(*, referer: str) -> Request[abcs.help.RecentMeUrls]:
    _buffer = bytearray(b'\x14\xf1\xc0=')
    serialize_bytes_to(_buffer, referer.encode('utf-8'))
    return Request(b'' + _buffer)
def get_terms_of_service_update() -> Request[abcs.help.TermsOfServiceUpdate]:
    _buffer = bytearray(b'\xd1\x1f\xa5,')
    return Request(b'' + _buffer)
def accept_terms_of_service(*, id: abcs.DataJson) -> Request[bool]:
    _buffer = bytearray(b'\x9a\xf7r\xee')
    id._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_deep_link_info(*, path: str) -> Request[abcs.help.DeepLinkInfo]:
    _buffer = bytearray(b'_\xc7\xed?')
    serialize_bytes_to(_buffer, path.encode('utf-8'))
    return Request(b'' + _buffer)
def get_app_config(*, hash: int) -> Request[abcs.help.AppConfig]:
    _buffer = bytearray(b'T\xf8\xe3a')
    _buffer += struct.pack('<i', hash)
    return Request(b'' + _buffer)
def save_app_log(*, events: Sequence[abcs.InputAppEvent]) -> Request[bool]:
    _buffer = bytearray(b'H\xf7\x02o')
    _buffer += struct.pack('<ii', 0x1cb5c415, len(events))
    for _t0 in events:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_passport_config(*, hash: int) -> Request[abcs.help.PassportConfig]:
    _buffer = bytearray(b'\x08\xada\xc6')
    _buffer += struct.pack('<i', hash)
    return Request(b'' + _buffer)
def get_support_name() -> Request[abcs.help.SupportName]:
    _buffer = bytearray(b',\xe7`\xd3')
    return Request(b'' + _buffer)
def get_user_info(*, user_id: abcs.InputUser) -> Request[abcs.help.UserInfo]:
    _buffer = bytearray(b'\xd3\x08\x8a\x03')
    user_id._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def edit_user_info(*, user_id: abcs.InputUser, message: str, entities: Sequence[abcs.MessageEntity]) -> Request[abcs.help.UserInfo]:
    _buffer = bytearray(b'p\x1b\xb9f')
    user_id._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, message.encode('utf-8'))
    _buffer += struct.pack('<ii', 0x1cb5c415, len(entities))
    for _t0 in entities:
      _t0._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def get_promo_data() -> Request[abcs.help.PromoData]:
    _buffer = bytearray(b'!t\x97\xc0')
    return Request(b'' + _buffer)
def hide_promo_data(*, peer: abcs.InputPeer) -> Request[bool]:
    _buffer = bytearray(b'\x95\x1c%\x1e')
    peer._write_boxed_to(_buffer)
    return Request(b'' + _buffer)
def dismiss_suggestion(*, peer: abcs.InputPeer, suggestion: str) -> Request[bool]:
    _buffer = bytearray(b'\xa1\xba\r\xf5')
    peer._write_boxed_to(_buffer)
    serialize_bytes_to(_buffer, suggestion.encode('utf-8'))
    return Request(b'' + _buffer)
def get_countries_list(*, lang_code: str, hash: int) -> Request[abcs.help.CountriesList]:
    _buffer = bytearray(b'\xa8\x87Ws')
    serialize_bytes_to(_buffer, lang_code.encode('utf-8'))
    _buffer += struct.pack('<i', hash)
    return Request(b'' + _buffer)
def get_premium_promo() -> Request[abcs.help.PremiumPromo]:
    _buffer = bytearray(b'\xd4\x93\x1b\xb8')
    return Request(b'' + _buffer)
